<html>
<head>
<title>Ogre::ShadowCaster Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1ShadowCaster.html">ShadowCaster</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::ShadowCaster Class Reference<div class="ingroups"><a class="el" href="group__Scene.html">Scene</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::ShadowCaster" -->
<p>This class defines the interface that must be implemented by shadow casters.  
 <a href="classOgre_1_1ShadowCaster.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::ShadowCaster:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1ShadowCaster__inherit__graph.gif" border="0" usemap="#Ogre_1_1ShadowCaster_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1ShadowCaster_inherit__map" id="Ogre_1_1ShadowCaster_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene." alt="" coords="199,352,343,381"/><area shape="rect" id="node5" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards." alt="" coords="453,5,595,35"/><area shape="rect" id="node9" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default..." alt="" coords="460,59,588,88"/><area shape="rect" id="node11" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh." alt="" coords="479,112,569,141"/><area shape="rect" id="node13" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi..." alt="" coords="471,165,577,195"/><area shape="rect" id="node17" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ..." alt="" coords="453,219,595,248"/><area shape="rect" id="node25" href="classOgre_1_1InstancedEntity.html" title="Ogre::InstancedEntity" alt="" coords="449,272,599,301"/><area shape="rect" id="node27" href="classOgre_1_1InstancedGeometry_1_1BatchInstance.html" title="The details of a topological BatchInstance which is the highest level of partitioning for this class..." alt="" coords="392,325,656,355"/><area shape="rect" id="node29" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene." alt="" coords="481,379,567,408"/><area shape="rect" id="node31" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry..." alt="" coords="455,432,593,461"/><area shape="rect" id="node33" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply..." alt="" coords="455,485,593,515"/><area shape="rect" id="node35" href="classOgre_1_1ParticleSystem.html" title="Class defining particle system based special effects." alt="" coords="451,539,597,568"/><area shape="rect" id="node37" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single&#45;part custom objects." alt="" coords="443,592,605,621"/><area shape="rect" id="node45" href="classOgre_1_1StaticGeometry_1_1Region.html" title="The details of a topological region which is the highest level of partitioning for this class..." alt="" coords="425,645,623,675"/><area shape="rect" id="node47" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html" title="MovableObject implementation to provide the hook to the scene." alt="" coords="403,699,645,728"/><area shape="rect" id="node7" href="classOgre_1_1RibbonTrail.html" title="Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances..." alt="" coords="783,5,905,35"/><area shape="rect" id="node15" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered." alt="" coords="792,139,896,168"/><area shape="rect" id="node19" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation..." alt="" coords="745,192,943,221"/><area shape="rect" id="node21" href="classOgre_1_1InstanceBatchHW.html" title="This is technique requires true instancing hardware support." alt="" coords="761,245,927,275"/><area shape="rect" id="node23" href="classOgre_1_1InstanceBatchShader.html" title="This is the same technique the old &quot;InstancedGeometry&quot; implementation used (with improvements)." alt="" coords="753,299,935,328"/><area shape="rect" id="node39" href="classOgre_1_1InstancedGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex &amp; index format is s..." alt="" coords="705,539,983,568"/><area shape="rect" id="node41" href="classOgre_1_1Rectangle2D.html" title="Allows the rendering of a simple 2D rectangle This class renders a simple 2D rectangle; this rectangl..." alt="" coords="777,592,911,621"/><area shape="rect" id="node43" href="classOgre_1_1WireBoundingBox.html" title="Allows the rendering of a wireframe bounding box." alt="" coords="763,645,925,675"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1ShadowCaster-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1ShadowRenderable.html">ShadowRenderable</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classOgre_1_1VectorIterator.html">VectorIterator</a><br class="typebreak"/>
&lt; <a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">ShadowRenderableListIterator</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#aa09c6e22f9879c123355bca19c1b7131">~ShadowCaster</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a35d47283265f36187263b2738e16c563">getCastShadows</a> (void) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether or not this object currently casts a shadow.  <a href="#a35d47283265f36187263b2738e16c563"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a9ec42d43470c2e2b0f6f05221371a786">getEdgeList</a> (void)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns details of the edges which might be used to determine a silhouette.  <a href="#a9ec42d43470c2e2b0f6f05221371a786"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a99cc616f547693f39fa354e6600368e6">hasEdgeList</a> (void)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the object has a valid edge list.  <a href="#a99cc616f547693f39fa354e6600368e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a6ab7144efe1ca481a4a9a89365ed522d">getWorldBoundingBox</a> (bool derive=false) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the world bounding box of the caster.  <a href="#a6ab7144efe1ca481a4a9a89365ed522d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#ad792b8137f18ea000c5bcbc5ae48814a">getLightCapBounds</a> (void) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the world space bounding box of the light cap.  <a href="#ad792b8137f18ea000c5bcbc5ae48814a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#aaa198e27c2c631a41f8f5f51ad7d7261">getDarkCapBounds</a> (const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> dirLightExtrusionDist) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the world space bounding box of the dark cap, as extruded using the light provided.  <a href="#aaa198e27c2c631a41f8f5f51ad7d7261"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <br class="typebreak"/>
<a class="el" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">ShadowRenderableListIterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a19cc1a66f375d77f2b4a52c42a0012d4">getShadowVolumeRenderableIterator</a> (<a class="el" href="group__General.html#ga79dcd426d291c31072c1ad6f183715d6">ShadowTechnique</a> shadowTechnique, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> *indexBuffer, bool <a class="el" href="classOgre_1_1ShadowCaster.html#acae2215c051989d544f34083a0a9bfa2">extrudeVertices</a>, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrusionDistance, unsigned long flags=0)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets an iterator over the renderables required to render the shadow volume.  <a href="#a19cc1a66f375d77f2b4a52c42a0012d4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a7f8a7e2e3a9876a8453e054335d7d23c">getPointExtrusionDistance</a> (const <a class="el" href="classOgre_1_1Light.html">Light</a> *l) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the distance to extrude for a point/spot light.  <a href="#a7f8a7e2e3a9876a8453e054335d7d23c"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#acae2215c051989d544f34083a0a9bfa2">extrudeVertices</a> (const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;vertexBuffer, size_t originalVertexCount, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Utility method for extruding vertices based on a light.  <a href="#acae2215c051989d544f34083a0a9bfa2"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a233233e14ccb869b6cafd655880355df">getExtrusionDistance</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;objectPos, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Helper method for calculating extrusion distance.  <a href="#a233233e14ccb869b6cafd655880355df"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#ac9a881430ec7769923f63f6df4b93d33">updateEdgeListLightFacing</a> (<a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *edgeData, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Tells the caster to perform the tasks necessary to update the edge data's light listing.  <a href="#ac9a881430ec7769923f63f6df4b93d33"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a396374525d65e0db10c7f7f8d380744a">generateShadowVolume</a> (<a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *edgeData, const <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> &amp;indexBuffer, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a> &amp;shadowRenderables, unsigned long flags)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.  <a href="#a396374525d65e0db10c7f7f8d380744a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCaster.html#a136dfd54b581a6dc58a1796a1cdf6cdc">extrudeBounds</a> (<a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;box, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;lightPos, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> extrudeDist) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Utility method for extruding a bounding box.  <a href="#a136dfd54b581a6dc58a1796a1cdf6cdc"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class defines the interface that must be implemented by shadow casters. </p>

<p>Definition at line <a class="el" href="OgreShadowCaster_8h_source.html#l00116">116</a> of file <a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="ad84ea1b2728ced5136add26c91c39a27"></a><!-- doxytag: member="Ogre::ShadowCaster::ShadowRenderableList" ref="ad84ea1b2728ced5136add26c91c39a27" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1ShadowRenderable.html">ShadowRenderable</a>*&gt;::type <a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">Ogre::ShadowCaster::ShadowRenderableList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCaster_8h_source.html#l00135">135</a> of file <a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7b0999d33e25db97d0449d6cf95cbecd"></a><!-- doxytag: member="Ogre::ShadowCaster::ShadowRenderableListIterator" ref="a7b0999d33e25db97d0449d6cf95cbecd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classOgre_1_1VectorIterator.html">VectorIterator</a>&lt;<a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a>&gt; <a class="el" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">Ogre::ShadowCaster::ShadowRenderableListIterator</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCaster_8h_source.html#l00136">136</a> of file <a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa09c6e22f9879c123355bca19c1b7131"></a><!-- doxytag: member="Ogre::ShadowCaster::~ShadowCaster" ref="aa09c6e22f9879c123355bca19c1b7131" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1ShadowCaster.html#aa09c6e22f9879c123355bca19c1b7131">Ogre::ShadowCaster::~ShadowCaster</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShadowCaster_8h_source.html#l00119">119</a> of file <a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a136dfd54b581a6dc58a1796a1cdf6cdc"></a><!-- doxytag: member="Ogre::ShadowCaster::extrudeBounds" ref="a136dfd54b581a6dc58a1796a1cdf6cdc" args="(AxisAlignedBox &amp;box, const Vector4 &amp;lightPos, Real extrudeDist) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ShadowCaster.html#a136dfd54b581a6dc58a1796a1cdf6cdc">Ogre::ShadowCaster::extrudeBounds</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&#160;</td>
          <td class="paramname"><em>box</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>extrudeDist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Utility method for extruding a bounding box. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">box</td><td>Original bounding box, will be updated in-place </td></tr>
    <tr><td class="paramname">lightPos</td><td>4D light position in object space, when w=0.0f this represents a directional light </td></tr>
    <tr><td class="paramname">extrudeDist</td><td>The distance to extrude </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acae2215c051989d544f34083a0a9bfa2"></a><!-- doxytag: member="Ogre::ShadowCaster::extrudeVertices" ref="acae2215c051989d544f34083a0a9bfa2" args="(const HardwareVertexBufferSharedPtr &amp;vertexBuffer, size_t originalVertexCount, const Vector4 &amp;lightPos, Real extrudeDist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static void <a class="el" href="classOgre_1_1ShadowCaster.html#acae2215c051989d544f34083a0a9bfa2">Ogre::ShadowCaster::extrudeVertices</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>vertexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>originalVertexCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>extrudeDist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Utility method for extruding vertices based on a light. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexBuffer</td><td>The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long. </td></tr>
    <tr><td class="paramname">originalVertexCount</td><td>The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by <a class="el" href="classOgre_1_1VertexData.html#a35751c0e63acf6def8a1cf101abd1b28" title="Modifies the vertex data to be suitable for use for rendering shadow geometry.">VertexData::prepareForShadowVolume</a>) to provide the extruded area of the buffer. </td></tr>
    <tr><td class="paramname">lightPos</td><td>4D light position in object space, when w=0.0f this represents a directional light </td></tr>
    <tr><td class="paramname">extrudeDist</td><td>The distance to extrude </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a396374525d65e0db10c7f7f8d380744a"></a><!-- doxytag: member="Ogre::ShadowCaster::generateShadowVolume" ref="a396374525d65e0db10c7f7f8d380744a" args="(EdgeData *edgeData, const HardwareIndexBufferSharedPtr &amp;indexBuffer, const Light *light, ShadowRenderableList &amp;shadowRenderables, unsigned long flags)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ShadowCaster.html#a396374525d65e0db10c7f7f8d380744a">Ogre::ShadowCaster::generateShadowVolume</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&#160;</td>
          <td class="paramname"><em>edgeData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>indexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1ShadowCaster.html#ad84ea1b2728ced5136add26c91c39a27">ShadowRenderableList</a> &amp;&#160;</td>
          <td class="paramname"><em>shadowRenderables</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>flags</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">edgeData</td><td>The edge information to use </td></tr>
    <tr><td class="paramname">indexBuffer</td><td>The buffer into which to write data into; current contents are assumed to be discardable. </td></tr>
    <tr><td class="paramname">light</td><td>The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing </td></tr>
    <tr><td class="paramname">shadowRenderables</td><td>A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used. </td></tr>
    <tr><td class="paramname">flags</td><td>Additional controller flags, see ShadowRenderableFlags </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a35d47283265f36187263b2738e16c563"></a><!-- doxytag: member="Ogre::ShadowCaster::getCastShadows" ref="a35d47283265f36187263b2738e16c563" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1ShadowCaster.html#a35d47283265f36187263b2738e16c563">Ogre::ShadowCaster::getCastShadows</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether or not this object currently casts a shadow. </p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#a70bca10cdeac93142d9f93ed0cf9c4c5">Ogre::MovableObject</a>, and <a class="el" href="classOgre_1_1TerrainQuadTreeNode_1_1Movable.html#a4b29457f7f870407fb1361202fe00eb0">Ogre::TerrainQuadTreeNode::Movable</a>.</p>

</div>
</div>
<a class="anchor" id="aaa198e27c2c631a41f8f5f51ad7d7261"></a><!-- doxytag: member="Ogre::ShadowCaster::getDarkCapBounds" ref="aaa198e27c2c631a41f8f5f51ad7d7261" args="(const Light &amp;light, Real dirLightExtrusionDist) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; <a class="el" href="classOgre_1_1ShadowCaster.html#aaa198e27c2c631a41f8f5f51ad7d7261">Ogre::ShadowCaster::getDarkCapBounds</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>dirLightExtrusionDist</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the world space bounding box of the dark cap, as extruded using the light provided. </p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#af06612d0607ebcf1bf5eb817c3038d52">Ogre::MovableObject</a>.</p>

</div>
</div>
<a class="anchor" id="a9ec42d43470c2e2b0f6f05221371a786"></a><!-- doxytag: member="Ogre::ShadowCaster::getEdgeList" ref="a9ec42d43470c2e2b0f6f05221371a786" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a>* <a class="el" href="classOgre_1_1ShadowCaster.html#a9ec42d43470c2e2b0f6f05221371a786">Ogre::ShadowCaster::getEdgeList</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns details of the edges which might be used to determine a silhouette. </p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#ab3d3d4e4aef1e2831572c2c052d29aec">Ogre::Entity</a>, <a class="el" href="classOgre_1_1MovableObject.html#a60b24cd45c8df45654dcfa14a1293a3b">Ogre::MovableObject</a>, <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#a111ad7217f020df5a38f8d218b7803c0">Ogre::StaticGeometry::Region</a>, and <a class="el" href="classOgre_1_1ManualObject.html#a5a53798ccf0c34105122ee77dad0904d">Ogre::ManualObject</a>.</p>

</div>
</div>
<a class="anchor" id="a233233e14ccb869b6cafd655880355df"></a><!-- doxytag: member="Ogre::ShadowCaster::getExtrusionDistance" ref="a233233e14ccb869b6cafd655880355df" args="(const Vector3 &amp;objectPos, const Light *light) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1ShadowCaster.html#a233233e14ccb869b6cafd655880355df">Ogre::ShadowCaster::getExtrusionDistance</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&#160;</td>
          <td class="paramname"><em>objectPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Helper method for calculating extrusion distance. </p>

</div>
</div>
<a class="anchor" id="ad792b8137f18ea000c5bcbc5ae48814a"></a><!-- doxytag: member="Ogre::ShadowCaster::getLightCapBounds" ref="ad792b8137f18ea000c5bcbc5ae48814a" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; <a class="el" href="classOgre_1_1ShadowCaster.html#ad792b8137f18ea000c5bcbc5ae48814a">Ogre::ShadowCaster::getLightCapBounds</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the world space bounding box of the light cap. </p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#af061175eb50a6aa98599ce0a748204b5">Ogre::MovableObject</a>.</p>

</div>
</div>
<a class="anchor" id="a7f8a7e2e3a9876a8453e054335d7d23c"></a><!-- doxytag: member="Ogre::ShadowCaster::getPointExtrusionDistance" ref="a7f8a7e2e3a9876a8453e054335d7d23c" args="(const Light *l) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1ShadowCaster.html#a7f8a7e2e3a9876a8453e054335d7d23c">Ogre::ShadowCaster::getPointExtrusionDistance</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>l</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the distance to extrude for a point/spot light. </p>

<p>Implemented in <a class="el" href="classOgre_1_1MovableObject.html#abb13b8e1b52d9dca9f5190f718686a5e">Ogre::MovableObject</a>.</p>

</div>
</div>
<a class="anchor" id="a19cc1a66f375d77f2b4a52c42a0012d4"></a><!-- doxytag: member="Ogre::ShadowCaster::getShadowVolumeRenderableIterator" ref="a19cc1a66f375d77f2b4a52c42a0012d4" args="(ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1ShadowCaster.html#a7b0999d33e25db97d0449d6cf95cbecd">ShadowRenderableListIterator</a> <a class="el" href="classOgre_1_1ShadowCaster.html#a19cc1a66f375d77f2b4a52c42a0012d4">Ogre::ShadowCaster::getShadowVolumeRenderableIterator</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__General.html#ga79dcd426d291c31072c1ad6f183715d6">ShadowTechnique</a>&#160;</td>
          <td class="paramname"><em>shadowTechnique</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1HardwareIndexBufferSharedPtr.html">HardwareIndexBufferSharedPtr</a> *&#160;</td>
          <td class="paramname"><em>indexBuffer</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>extrudeVertices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>extrusionDistance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>flags</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets an iterator over the renderables required to render the shadow volume. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Shadowable geometry should ideally be designed such that there is only one <a class="el" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a> required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">shadowTechnique</td><td>The technique being used to generate the shadow </td></tr>
    <tr><td class="paramname">light</td><td>The light to generate the shadow from </td></tr>
    <tr><td class="paramname">indexBuffer</td><td>The index buffer to build the renderables into, the current contents are assumed to be disposable. </td></tr>
    <tr><td class="paramname">extrudeVertices</td><td>If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed). </td></tr>
    <tr><td class="paramname">extrusionDistance</td><td>The distance to extrude the shadow volume </td></tr>
    <tr><td class="paramname">flags</td><td>Technique-specific flags, see ShadowRenderableFlags </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#a5c2c5a1d7923238f10b78c030c57a5ea">Ogre::Entity</a>, <a class="el" href="classOgre_1_1MovableObject.html#a4492fa817bb3a750d349aeec34c19c43">Ogre::MovableObject</a>, <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#ac0d6ab629e47ee3bb10f87f65930c885">Ogre::StaticGeometry::Region</a>, and <a class="el" href="classOgre_1_1ManualObject.html#ae76e83dd4c4c61f2428d1b78fa40824d">Ogre::ManualObject</a>.</p>

</div>
</div>
<a class="anchor" id="a6ab7144efe1ca481a4a9a89365ed522d"></a><!-- doxytag: member="Ogre::ShadowCaster::getWorldBoundingBox" ref="a6ab7144efe1ca481a4a9a89365ed522d" args="(bool derive=false) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a>&amp; <a class="el" href="classOgre_1_1ShadowCaster.html#a6ab7144efe1ca481a4a9a89365ed522d">Ogre::ShadowCaster::getWorldBoundingBox</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>derive</em> = <code>false</code></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the world bounding box of the caster. </p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#a5edde0278ae3942c9816690cb3462853">Ogre::Entity</a>, and <a class="el" href="classOgre_1_1MovableObject.html#acc31c877990c3c231c4b4cfb0522bef8">Ogre::MovableObject</a>.</p>

</div>
</div>
<a class="anchor" id="a99cc616f547693f39fa354e6600368e6"></a><!-- doxytag: member="Ogre::ShadowCaster::hasEdgeList" ref="a99cc616f547693f39fa354e6600368e6" args="(void)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1ShadowCaster.html#a99cc616f547693f39fa354e6600368e6">Ogre::ShadowCaster::hasEdgeList</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether the object has a valid edge list. </p>

<p>Implemented in <a class="el" href="classOgre_1_1Entity.html#af155dfe2635fad3ed2aff25fcde75421">Ogre::Entity</a>, <a class="el" href="classOgre_1_1MovableObject.html#ab7c2a8be6a9bd59e6c69ee2d76945500">Ogre::MovableObject</a>, <a class="el" href="classOgre_1_1StaticGeometry_1_1Region.html#a5ff65b3d2928d260e96535cff3ce2ffb">Ogre::StaticGeometry::Region</a>, and <a class="el" href="classOgre_1_1ManualObject.html#a77b98b65fbf51b3b611b4e423c74fe79">Ogre::ManualObject</a>.</p>

</div>
</div>
<a class="anchor" id="ac9a881430ec7769923f63f6df4b93d33"></a><!-- doxytag: member="Ogre::ShadowCaster::updateEdgeListLightFacing" ref="ac9a881430ec7769923f63f6df4b93d33" args="(EdgeData *edgeData, const Vector4 &amp;lightPos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ShadowCaster.html#ac9a881430ec7769923f63f6df4b93d33">Ogre::ShadowCaster::updateEdgeListLightFacing</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1EdgeData.html">EdgeData</a> *&#160;</td>
          <td class="paramname"><em>edgeData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&#160;</td>
          <td class="paramname"><em>lightPos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tells the caster to perform the tasks necessary to update the edge data's light listing. </p>
<p>Can be overridden if the subclass needs to do additional things. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">edgeData</td><td>The edge information to update </td></tr>
    <tr><td class="paramname">lightPos</td><td>4D vector representing the light, a directional light has w=0.0 </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCaster_8h_source.html">OgreShadowCaster.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:07
</p>
</body>
</html>
